﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnitLibrary.Managers;
using FarseerGames.FarseerPhysics;
using UnitLibrary;

namespace UnitLibrary.GameObjects
{
    /// <summary>
    /// Public class which can only be inherited. 
    /// <remarks>Class is to be used as based type for all in game objects
    /// This will allow the components to properly identify the manager it belongs to
    /// and the node index inside the manager</remarks>
    /// </summary>
    public class GameObjectID
    {
        public GameObjectID() { }

        public GameObjectID(int nodeID, UnitID poolID)
        {
            this._nodeID = nodeID;
            this._poolID = poolID;           
        }  

        private int _nodeID;     
        private UnitID _poolID;

        public int NodeID
        {
            get { return _nodeID; }

        }

        public UnitID UnitID
        {
            get { return _poolID; }
        }
    }
}
